package cn.net.cpzslibs.prot.handset.jinLiquor;

import com.google.gson.Gson;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;

import cn.net.cpzslibs.prot.ProtBase;
import cn.net.cpzslibs.prot.SocketCreate;
import cn.net.cpzslibs.prot.handset.bean.res.jinLiquor.Jin20004ResBean;
import cn.net.cpzslibs.prot.utils.StrUtils;


public class Jin20004Product extends ProtBase {
	
	private final short iTaskCode20004 = 20004;
	private Gson gson;
	private Jin20004ResBean resBean;
	
	public Jin20004Product() {
//		this.sInspectorId = sInspectorId;
		gson = new Gson();
	}
	
	public Jin20004ResBean getResBean(){
		return this.resBean;
	}
	
	public void reqProduct(SocketCreate create) throws IOException {
		recProt(create.getSocket(), create.getDos(), create.getDis());
	}
	
	private void recProt(Socket socket, DataOutputStream dos,
			DataInputStream dis)
			throws IOException {
		if (socket.isConnected()) {
			if (!socket.isOutputShutdown()) {
				//发送登录信息
				debugLog(iTaskCode20004, "开始请求信息");
				sendProt(dos);
			}
		}
		if (socket.isConnected()) {
			if (!socket.isInputShutdown()) {
				recLoginDis(dis);
			}
		}
	}
	
	/**
	 * 读取JSon数据
	 * @param dis
	 * @throws IOException
	 */
	private void recLoginDis(DataInputStream dis) throws IOException {
		debugLog(iTaskCode20004, "获取接收的数据");
		recHeader(dis);
		int jsonLength = getiRecBodySize() - 2;
		String jsonData = getUTF8(dis, jsonLength);
		debugLog(iTaskCode20004, jsonData);
		if (!StrUtils.isEmpty(jsonData)) {
			resBean = gson.fromJson(jsonData, Jin20004ResBean.class);
		}
//		System.err.println("resBean: " + resBean.toString());
//		
		recCheckCode(dis);
	}
	
	
	/**
	 * 发送JSon数据到服务器
	 * @param dos
	 * @param iUserType
	 * @param loginBean
	 * @throws IOException
	 */
	private void sendProt(DataOutputStream dos) throws IOException {
		String bodyContent = "{}";
		short bodySize = countBodySize(bodyContent);
		sendHeader(dos, iTaskCode20004, bodySize);// 84
		dos.write(bodyContent.getBytes("UTF-8"));
//		sendCheckCode(dos);
		sendCheckCoded(dos,bodyContent.getBytes("UTF-8"));
	}
	

}
